import numpy as np
import tensorflow as tf
import glob
import os
from PIL import Image

imagePath = "./face/out"
# TensorFlow Liteモデルの読み込み
interpreter = tf.lite.Interpreter("/home/dlwork02/pedet/models/output_quant.tflite")
#interpreter = tf.lite.Interpreter("/home/dlwork02/pedet/model.tflite")
interpreter.allocate_tensors()

# 入力テンソルと出力テンソルのインデックスを取得
input_index = interpreter.get_input_details()[0]["index"]
output_index = interpreter.get_output_details()[0]["index"]

# 画像の読み込みと前処理
filePathList = glob.glob(os.path.join(imagePath, "*.[Jj][Pp][Gg]"))
for filePath in filePathList:
    image = Image.open(filePath).resize((224, 224))
    image_array = np.asarray(image, dtype=np.float32)
    image_array = image_array / 127.5 - 1  # floatからint8に変換
    image_array = np.expand_dims(image_array, axis=0)

    # 推論の実行
    interpreter.set_tensor(input_index, image_array.astype(np.int8))
    interpreter.invoke()
    output_data = interpreter.get_tensor(output_index)

    # 結果の表示
    print("Output:", output_data)